/**
 * Fuse.js v5.2.2 - Lightweight fuzzy-search (http://fusejs.io)
 *
 * Copyright (c) 2020 Kiro Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 */
const t=t=>Array.isArray?Array.isArray(t):"[object Array]"===Object.prototype.toString.call(t),e=t=>"string"==typeof t,s=t=>"number"==typeof t,n=t=>null!=t,i=t=>!t.trim().length;var r={isCaseSensitive:!1,includeScore:!1,keys:[],shouldSort:!0,sortFn:(t,e)=>t.score===e.score?t.refIndex<e.refIndex?-1:1:t.score<e.score?-1:1,includeMatches:!1,findAllMatches:!1,minMatchCharLength:1,location:0,threshold:.6,distance:100,...{useExtendedSearch:!1,getFn:function(i,r){let h=[],o=!1;const c=(i,r)=>{if(r){const l=r.indexOf(".");let a=r,d=null;-1!==l&&(a=r.slice(0,l),d=r.slice(l+1));const u=i[a];if(n(u))if(d||!e(u)&&!s(u))if(t(u)){o=!0;for(let t=0,e=u.length;t<e;t+=1)c(u[t],d)}else d&&c(u,d);else h.push((t=>null==t?"":(t=>{if("string"==typeof t)return t;let e=t+"";return"0"==e&&1/t==-1/0?"-0":e})(t))(u))}else h.push(i)};return c(i,r),o?h:h[0]}}};function h(t,{errors:e=0,currentLocation:s=0,expectedLocation:n=0,distance:i=r.distance}={}){const h=e/t.length,o=Math.abs(n-s);return i?h+o/i:o?1:h}function o(t,e,s,{location:n=r.location,distance:i=r.distance,threshold:o=r.threshold,findAllMatches:c=r.findAllMatches,minMatchCharLength:l=r.minMatchCharLength,includeMatches:a=r.includeMatches}={}){if(e.length>32)throw new Error("Pattern length exceeds max of 32.");const d=e.length,u=t.length,f=Math.max(0,Math.min(n,u));let g=o,p=f;const y=[];if(a)for(let t=0;t<u;t+=1)y[t]=0;let m;for(;(m=t.indexOf(e,p))>-1;){let t=h(e,{currentLocation:m,expectedLocation:f,distance:i});if(g=Math.min(t,g),p=m+d,a){let t=0;for(;t<d;)y[m+t]=1,t+=1}}p=-1;let M=[],x=1,k=d+u;const _=1<<(d<=31?d-1:30);for(let n=0;n<d;n+=1){let r=0,o=k;for(;r<o;){h(e,{errors:n,currentLocation:f+o,expectedLocation:f,distance:i})<=g?r=o:k=o,o=Math.floor((k-r)/2+r)}k=o;let l=Math.max(1,f-o+1),m=c?u:Math.min(f+o,u)+d,I=Array(m+2);I[m+1]=(1<<n)-1;for(let r=m;r>=l;r-=1){let o=r-1,c=s[t.charAt(o)];if(c&&a&&(y[o]=1),I[r]=(I[r+1]<<1|1)&c,0!==n&&(I[r]|=(M[r+1]|M[r])<<1|1|M[r+1]),I[r]&_&&(x=h(e,{errors:n,currentLocation:o,expectedLocation:f,distance:i}),x<=g)){if(g=x,p=o,p<=f)break;l=Math.max(1,2*f-p)}}if(h(e,{errors:n+1,currentLocation:f,expectedLocation:f,distance:i})>g)break;M=I}let I={isMatch:p>=0,score:x||.001};return a&&(I.matchedIndices=function(t=[],e=r.minMatchCharLength){let s=[],n=-1,i=-1,h=0;for(let r=t.length;h<r;h+=1){let r=t[h];r&&-1===n?n=h:r||-1===n||(i=h-1,i-n+1>=e&&s.push([n,i]),n=-1)}return t[h-1]&&h-n>=e&&s.push([n,h-1]),s}(y,l)),I}function c(t){let e={},s=t.length;for(let n=0;n<s;n+=1)e[t.charAt(n)]=0;for(let n=0;n<s;n+=1)e[t.charAt(n)]|=1<<s-n-1;return e}class l{constructor(t,{location:e=r.location,threshold:s=r.threshold,distance:n=r.distance,includeMatches:i=r.includeMatches,findAllMatches:h=r.findAllMatches,minMatchCharLength:o=r.minMatchCharLength,isCaseSensitive:l=r.isCaseSensitive}={}){this.options={location:e,threshold:s,distance:n,includeMatches:i,findAllMatches:h,minMatchCharLength:o,isCaseSensitive:l},this.pattern=l?t:t.toLowerCase(),this.chunks=[];let a=0;for(;a<this.pattern.length;){let t=this.pattern.substring(a,a+32);this.chunks.push({pattern:t,alphabet:c(t)}),a+=32}}searchIn(t){let e=t.$;return this.searchInString(e)}searchInString(t){const{isCaseSensitive:e,includeMatches:s}=this.options;if(e||(t=t.toLowerCase()),this.pattern===t){let e={isMatch:!0,score:0};return s&&(e.matchedIndices=[[0,t.length-1]]),e}const{location:n,distance:i,threshold:r,findAllMatches:h,minMatchCharLength:c}=this.options;let l=[],a=0,d=!1;for(let e=0,u=this.chunks.length;e<u;e+=1){let{pattern:u,alphabet:f}=this.chunks[e],g=o(t,u,f,{location:n+32*e,distance:i,threshold:r,findAllMatches:h,minMatchCharLength:c,includeMatches:s});const{isMatch:p,score:y,matchedIndices:m}=g;p&&(d=!0),a+=y,p&&m&&(l=[...l,...m])}let u={isMatch:d,score:d?a/this.chunks.length:1};return d&&s&&(u.matchedIndices=l),u}}const a=/[^ ]+/g;function d(s,h,{getFn:o=r.getFn}={}){let c=[];if(e(h[0]))for(let t=0,e=h.length;t<e;t+=1){const e=h[t];if(n(e)&&!i(e)){let s={$:e,idx:t,t:e.match(a).length};c.push(s)}}else{const r=s.length;for(let l=0,d=h.length;l<d;l+=1){let d=h[l],u={idx:l,$:{}};for(let h=0;h<r;h+=1){let r=s[h],c=o(d,r);if(n(c))if(t(c)){let s=[];const h=[{arrayIndex:-1,value:c}];for(;h.length;){const{arrayIndex:r,value:o}=h.pop();if(n(o))if(e(o)&&!i(o)){let t={$:o,idx:r,t:o.match(a).length};s.push(t)}else if(t(o))for(let t=0,e=o.length;t<e;t+=1)h.push({arrayIndex:t,value:o[t]})}u.$[r]=s}else if(!i(c)){let t={$:c,t:c.match(a).length};u.$[r]=t}}c.push(u)}}return c}class u{constructor(t){if(this._keys={},this._keyNames=[],this._length=t.length,t.length&&e(t[0]))for(let e=0;e<this._length;e+=1){const s=t[e];this._keys[s]={weight:1},this._keyNames.push(s)}else{let e=0;for(let s=0;s<this._length;s+=1){const n=t[s];if(!Object.prototype.hasOwnProperty.call(n,"name"))throw new Error('Missing "name" property in key object');const i=n.name;if(this._keyNames.push(i),!Object.prototype.hasOwnProperty.call(n,"weight"))throw new Error('Missing "weight" property in key object');const r=n.weight;if(r<=0||r>=1)throw new Error('"weight" property in key must be in the range of (0, 1)');this._keys[i]={weight:r},e+=r}for(let t=0;t<this._length;t+=1){const s=this._keyNames[t],n=this._keys[s].weight;this._keys[s].weight=n/e}}}get(t,e){return this._keys[t]?this._keys[t][e]:-1}keys(){return this._keyNames}count(){return this._length}toJSON(){return JSON.stringify(this._keys)}}function f(t,e){const s=t.matches;if(e.matches=[],n(s))for(let t=0,i=s.length;t<i;t+=1){let i=s[t];if(!n(i.indices)||0===i.indices.length)continue;let r={indices:i.indices,value:i.value};i.key&&(r.key=i.key),i.idx>-1&&(r.refIndex=i.idx),e.matches.push(r)}}function g(t,e){e.score=t.score}const p=[];class y{constructor(t,e={},s=null){this.options={...r,...e},this._processKeys(this.options.keys),this.setCollection(t,s)}setCollection(t,s=null){this.list=t,this.listIsStringArray=e(t[0]),s?this.setIndex(s):this.setIndex(this._createIndex())}setIndex(t){this._indexedList=t}_processKeys(t){this._keyStore=new u(t)}_createIndex(){return d(this._keyStore.keys(),this.list,{getFn:this.options.getFn})}search(t,e={limit:!1}){if(!(t=t.trim()).length)return[];const{shouldSort:n}=this.options;let i=null;for(let e=0,s=p.length;e<s;e+=1){let s=p[e];if(s.condition(t,this.options)){i=new s(t,this.options);break}}i||(i=new l(t,this.options));let r=this._searchUsing(i);return this._computeScore(r),n&&this._sort(r),e.limit&&s(e.limit)&&(r=r.slice(0,e.limit)),this._format(r)}_searchUsing(e){const s=this._indexedList,i=[],{includeMatches:r}=this.options;if(this.listIsStringArray)for(let t=0,h=s.length;t<h;t+=1){let h=s[t],{$:o,idx:c,t:l}=h;if(!n(o))continue;let a=e.searchIn(h);const{isMatch:d,score:u}=a;if(!d)continue;let f={score:u,value:o,t:l};r&&(f.indices=a.matchedIndices),i.push({item:o,idx:c,matches:[f]})}else{const h=this._keyStore.keys(),o=this._keyStore.count();for(let c=0,l=s.length;c<l;c+=1){let{$:l,idx:a}=s[c];if(!n(l))continue;let d=[];for(let s=0;s<o;s+=1){let i=h[s],o=l[i];if(n(o))if(t(o))for(let t=0,s=o.length;t<s;t+=1){let s=o[t];const{$:h,idx:c,t:l}=s;if(!n(h))continue;let a=e.searchIn(s);const{isMatch:u,score:f}=a;if(!u)continue;let g={score:f,key:i,value:h,idx:c,t:l};r&&(g.indices=a.matchedIndices),d.push(g)}else{const{$:t,t:s}=o;let n=e.searchIn(o);const{isMatch:h,score:c}=n;if(!h)continue;let l={score:c,key:i,value:t,t:s};r&&(l.indices=n.matchedIndices),d.push(l)}}d.length&&i.push({idx:a,item:l,matches:d})}}return i}_computeScore(t){const e=t.length;for(let s=0;s<e;s+=1){const e=t[s],n=e.matches,i=n.length;let r=1;for(let t=0;t<i;t+=1){const e=n[t],{key:s,t:i}=e,h=this._keyStore.get(s,"weight"),o=h>-1?h:1,c=0===e.score&&h>-1?Number.EPSILON:e.score,l=1/Math.sqrt(i);r*=Math.pow(c,o*l)}e.score=r}}_sort(t){t.sort(this.options.sortFn)}_format(t){const e=[],{includeMatches:s,includeScore:n}=this.options;let i=[];s&&i.push(f),n&&i.push(g);for(let s=0,n=t.length;s<n;s+=1){const n=t[s],{idx:r}=n,h={item:this.list[r],refIndex:r};if(i.length)for(let t=0,e=i.length;t<e;t+=1)i[t](n,h);e.push(h)}return e}}y.version="5.2.2",y.createIndex=d,y.config=r;export default y;